import java.io.*;
import java.net.*;
import java.awt.*;

public class Authenticator {
    // private int                     numThreads;
    private static int              maxThreads = 40;
    private AuthenticatorSecrets    as;
    private AuthenticatorKeyPair    akp;
    private int                     port;
    private int                     sport;

    protected Authenticator() {};

    protected void init(int p, int s) {
        // numThreads = 0;
        as = new AuthenticatorSecrets();
        System.out.println("Generating key pair....");
        akp = new AuthenticatorKeyPair();
        System.out.println("Ready....");
        port = p;
        sport = s;
    }

    protected void run() {
        try {

            // Start the main thread to check available server status
            new AuthenticatorMainThread(as, akp, sport).start();

            // start infinite loop to wait for clients' connections
            int i = 1;
            ServerSocket s = new ServerSocket(port, 10);

            System.gc();

            for (;;) {
                // if (numThreads < maxThreads) {
                    Socket incoming = s.accept();
                    incoming.setSoTimeout(300000);
                    System.out.println("Spawning Authentication Thread " + i);
                    new AuthenticatorThreadSocketHandler(incoming, as).start();
                    i++;
                // }
            }
        } catch (Exception ex) {
            System.err.println("Authenticator Exception->" + ex);
        }
    }

    public static void main(String[] args) {
        System.out.println("Authenticator is starting");
        if (args.length != 4) {
            System.err.println("java Authenticator -Port # -SPort #\n" +
                               "    -Port:  port number for Server verification connections\n" +
                               "    -SPort: port number for Server secretkey agreement");
            System.exit(1);
        }

        int i = 0;
        while (!args[i++].equals("-Port") && (i < args.length)) {}
        int p = Integer.parseInt(args[i]);

        i = 0;
        while (!args[i++].equals("-SPort") && (i < args.length)) {}
        int s = Integer.parseInt(args[i]);

        Authenticator a = new Authenticator();
        a.init(p, s);
        a.run();
    }
}
