import java.io.*;
import java.net.*;
import java.security.*;
import javax.crypto.*;

public class AuthenticatorChildThreadSocketHandler extends Thread {

    private Socket                   socket;
    private AuthenticatorSecuredComm asc;
    private String                   host;
    private int                      port;
    private AuthenticatorSecrets     as;
    private int                      id;

    public AuthenticatorChildThreadSocketHandler(Socket s, AuthenticatorSecrets a,
                     AuthenticatorKeyPair akp) {
        socket = s;
        as = a;
        asc = new AuthenticatorSecuredComm(socket, akp);
    }

    public void run() {
        try {
            if (!asc.init()) {
                System.err.println("AuthenticatorSecuredComm.init(): failed.");
            }

            int id = ((Integer)asc.getObjectInputStream().readObject()).intValue();
            System.err.println("AuthenticatorChildThreadSocketHandler " + id);
            if (asc.getSecretKey() == null) System.err.println("NULL");
            as.setSecretKey(id, asc.getSecretKey());

        } catch (Exception ex) {
            System.err.println("AuthenticatorChildThreadSocketHandler Exception-> " + ex);
        }
        asc.done();
    }
}
