import java.io.*;
import java.net.*;
import java.util.*;

public class AuthenticatorMainThread extends Thread {
    private AuthenticatorSecrets   as;
    private AuthenticatorKeyPair   akp;
    private int                    port;

    public AuthenticatorMainThread(AuthenticatorSecrets a, AuthenticatorKeyPair ak,
                                 int p) {
        as = a;
        akp = ak;
        port = p;
    }

    public void run() {
        int i = 1;
        int j = 0;

        try {
            ServerSocket s = new ServerSocket(port);
            for (;;) {
                Socket incoming = s.accept();
                incoming.setSoTimeout(180000);
                System.out.println("Spawning AuthenticatorChild Secret Thread " + i);
                new AuthenticatorChildThreadSocketHandler(incoming, as, akp).start();
                i++;
            }
        } catch (Exception ex) {
            System.err.println("AuthenticatorMainThread Exception->" + ex);
        }
    }
}
