import java.io.*;
import java.net.*;
import java.awt.*;

public class Coordinator {
    private int                   numThreads;
    private static int            maxThreads = 40;
    private CoordinatorServerInfo csi;
    private CoordinatorKeyPair    ckp;
    private int                   port;
    private int                   mport;

    protected Coordinator() {};

    protected void init(int p, int m) {
        numThreads = 0;
        csi = new CoordinatorServerInfo();
        System.out.println("Generating key pair....");
        ckp = new CoordinatorKeyPair();
        System.out.println("Ready....");
        port = p;
        mport = m;
    }

    protected void run() {
        try {

            // Start the main thread to check available server status
            new CoordinatorMainThread(csi, ckp, mport).start();

            // Start thread for Console
            new CoordinatorManagerThread(csi).start();

            // start infinite loop to wait for clients' connections
            int i = 1;
            ServerSocket s = new ServerSocket(port, maxThreads);
            for (;;) {
                if (numThreads < maxThreads) {
                    Socket incoming = s.accept();
                    System.out.println("Spawning Service Thread " + i);
                    incoming.setSoTimeout(300000);
                    new CoordinatorThreadSocketHandler(incoming, csi).start();
                    i++;
                }
            }
        } catch (Exception ex) {
            System.err.println("Coordinator Exception->" + ex);
        }
    }

    public void releaseThread() {
        numThreads--;
    }
        
    public static void main(String[] args) {
        System.out.println("Coordinator is starting");
        if (args.length != 4) {
            System.err.println("java Coordinator -Port # -MPort #\n" +
                               "    -Port:  port number for clients' connections\n" +
                               "    -MPort: port number for Servers' registrations");
            System.exit(1);
        }

        int i = 0;
        while (!args[i++].equals("-Port")) {};
        int p = Integer.parseInt(args[i]);

        i = 0;
        while (!args[i++].equals("-MPort")) {};
        int m = Integer.parseInt(args[i]);

        System.out.println("Coordinator Started");
        Coordinator s = new Coordinator();
        s.init(p, m);
        s.run();
    }
}
