import java.io.*;
import java.net.*;
import java.util.*;

public class CoordinatorMainThread extends Thread {
    private CoordinatorServerInfo    csi;
    private CoordinatorKeyPair       ckp;
    private int                      port;

    public CoordinatorMainThread(CoordinatorServerInfo c, CoordinatorKeyPair ck,
                                 int p) {
        csi = c;
        ckp = ck;
        port = p;
    }

    public void run() {
        int i = 1;
        int j = 0;

        try {
            ServerSocket s = new ServerSocket(port);
            for (;;) {
                Socket incoming = s.accept();
                System.out.println("Spawning CoordinatorChild Checking Thread " + i);
                new CoordinatorChildThreadSocketHandler(incoming, csi, ckp).start();
                i++;
            }
        } catch (Exception ex) {
            System.err.println("CoordinatorMainThread Exception->" + ex);
        }
    }
}
