import java.awt.*;
import java.awt.event.*;

class ClientStatusPanel extends Panel {
    private Insets             mInsets = new Insets(3,3,3,3);
    private Label              statusLabel;
    public  TextField          statusField;
    private GridBagLayout      gb = new GridBagLayout();
    private GridBagConstraints gbc = new GridBagConstraints();
    private ActionListener     al;

    public ClientStatusPanel (ActionListener a) {

        setBackground(new Color(200, 250, 250));
        setLayout(gb);

        gbc.anchor      = GridBagConstraints.CENTER;
        gbc.fill        = GridBagConstraints.BOTH;
        gbc.gridwidth   = GridBagConstraints.REMAINDER;
        gbc.gridx       = 0;
        gbc.gridy       = 0;
        gbc.gridwidth   = 1;
        gbc.gridheight  = 1;
        statusLabel = makeLabel("Status: ", 12, 1);

        gbc.gridx       = 1;
        statusField = makeTextField("", false);
        statusField.setEditable(false);
    }

    protected
    TextField  makeTextField(String name,
                             boolean passwd) {

        TextField field = new TextField(45);
        if (passwd) {
            field.setEchoChar('*');
        }
        field.addActionListener(al);
        gb.setConstraints(field, gbc);
        add(field);

        return field;
    }

    protected
    Label makeLabel(String name,
                    int size,
                    int position) {

        Label label;
        if (position == 0) {
            label = new Label(name, Label.CENTER);
        } else {
            label = new Label(name, Label.RIGHT);
        }

        label.setFont(new Font("Helvetica", Font.BOLD, size));
        gb.setConstraints(label, gbc);
        add(label);

        return label;
    }

    public Insets
    getInsets()
    {
        return mInsets;
    }

    public void
    setText(String s) {
        statusField.setText(s);
    }
}
