import java.io.*;
import java.net.*;
import java.awt.*;

public class UPServer {
    private int                     numThreads;
    private static int              maxThreads = 40;
    private UPServerKeyPair         upskp;
    private int                     port;
    private int                     sport;
    private UPServerPool            upsp;

    protected UPServer() {};

    protected void init(int p) {
        numThreads = 0;
        System.out.println("Generating key pair....");
        upskp = new UPServerKeyPair();
        port = p;
        upsp = new UPServerPool();
    }

    protected void run() {
        try {

            // start infinite loop to wait for clients' connections
            int i = 1;
            ServerSocket s = new ServerSocket(port, maxThreads);
            System.out.println("Ready....");
            for (;;) {
                if (numThreads < maxThreads) {
                    Socket incoming = s.accept();
                    System.out.println("Spawning Service Thread " + i);
                    incoming.setSoTimeout(300000);
                    new UPServerThreadSocketHandler(incoming, upsp, upskp).start();
                    i++;
                }
            }
        } catch (Exception ex) {
            System.err.println("UPServer Exception->" + ex);
        }
    }

    public static void main(String[] args) {
        System.out.println("UPServer is starting");
        if (args.length != 2) {
            System.err.println("java UPServer -Port #\n" +
                               "    -Port:  port number for UPServer connections");
            System.exit(1);
        }

        int i = 0;
        while (!args[i++].equals("-Port") && (i < args.length)) {}
        int p = Integer.parseInt(args[i]);

        UPServer u = new UPServer();
        u.init(p);
        u.run();
    }
}
